
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Service_technologiesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const service_technologies = await db.service_technologies.create(
            {
                id: data.id || undefined,
        
        note_ar: data.note_ar
        ||
        null
            ,
            
        sort_order: data.sort_order
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await service_technologies.setService( data.service || null, {
            transaction,
        });
        
        await service_technologies.setTechnology( data.technology || null, {
            transaction,
        });
        

        

        

        return service_technologies;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const service_technologiesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                note_ar: item.note_ar
            ||
            null
            ,
            
                sort_order: item.sort_order
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const service_technologies = await db.service_technologies.bulkCreate(service_technologiesData, { transaction });

        // For each item created, replace relation files
        

        return service_technologies;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const service_technologies = await db.service_technologies.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.note_ar !== undefined) updatePayload.note_ar = data.note_ar;
        
        
        if (data.sort_order !== undefined) updatePayload.sort_order = data.sort_order;
        
        
        updatePayload.updatedById = currentUser.id;

        await service_technologies.update(updatePayload, {transaction});

        
        
        if (data.service !== undefined) {
            await service_technologies.setService(
              
              data.service,
              
              { transaction }
            );
        }
        
        if (data.technology !== undefined) {
            await service_technologies.setTechnology(
              
              data.technology,
              
              { transaction }
            );
        }
        

        
        

        

        return service_technologies;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const service_technologies = await db.service_technologies.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of service_technologies) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of service_technologies) {
                await record.destroy({transaction});
            }
        });


        return service_technologies;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const service_technologies = await db.service_technologies.findByPk(id, options);

        await service_technologies.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await service_technologies.destroy({
            transaction
        });

        return service_technologies;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const service_technologies = await db.service_technologies.findOne(
            { where },
            { transaction },
        );

        if (!service_technologies) {
            return service_technologies;
        }

        const output = service_technologies.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.service = await service_technologies.getService({
            transaction
        });
        
        
        output.technology = await service_technologies.getTechnology({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.services,
        as: 'service',
        
        where: filter.service ? {
          [Op.or]: [
            { id: { [Op.in]: filter.service.split('|').map(term => Utils.uuid(term)) } },
            {
              name_ar: {
                [Op.or]: filter.service.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.technologies,
        as: 'technology',
        
        where: filter.technology ? {
          [Op.or]: [
            { id: { [Op.in]: filter.technology.split('|').map(term => Utils.uuid(term)) } },
            {
              name_ar: {
                [Op.or]: filter.technology.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.note_ar) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'service_technologies',
                        'note_ar',
                        filter.note_ar,
                    ),
                };
            }
            

            
            

            
            if (filter.sort_orderRange) {
                const [start, end] = filter.sort_orderRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.service_technologies.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'service_technologies',
                        'note_ar',
                        query,
                    ),
                ],
            };
        }

        const records = await db.service_technologies.findAll({
            attributes: [ 'id', 'note_ar' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['note_ar', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.note_ar,
        }));
    }

    
};

